"use strict";
Object.defineProperty(exports, "__esModule", {
    value: true
});
Object.defineProperty(exports, "convertToLocaleString", {
    enumerable: true,
    get: function() {
        return convertToLocaleString;
    }
});
const convertToLocaleString = (data, culture)=>{
    if (!data) {
        return data;
    }
    culture = culture || undefined;
    if (typeof data === 'number') {
        return data.toLocaleString(culture);
    } else if (typeof data === 'string' && !isNaN(Number(data))) {
        const num = Number(data);
        return num.toLocaleString(culture);
    } else if (data instanceof Date) {
        return data.toLocaleDateString(culture);
    }
    return data;
};
