/**
 * Detects whether an element's content has horizontal overflow
 *
 * @public
 * @param element - Element to check for overflow
 * @returns True if element's content overflows
 */ "use strict";
Object.defineProperty(exports, "__esModule", {
    value: true
});
function _export(target, all) {
    for(var name in all)Object.defineProperty(target, name, {
        enumerable: true,
        get: all[name]
    });
}
_export(exports, {
    hasHorizontalOverflow: function() {
        return hasHorizontalOverflow;
    },
    hasOverflow: function() {
        return hasOverflow;
    },
    hasVerticalOverflow: function() {
        return hasVerticalOverflow;
    }
});
function hasHorizontalOverflow(element) {
    return element.clientWidth < element.scrollWidth;
}
function hasVerticalOverflow(element) {
    return element.clientHeight < element.scrollHeight;
}
function hasOverflow(element) {
    return hasHorizontalOverflow(element) || hasVerticalOverflow(element);
}
