import { __styles, mergeClasses, shorthands } from '@griffel/react';
import { HighContrastSelectorBlack, HighContrastSelector } from '../../utilities/index';
import { tokens, typographyStyles } from '@fluentui/react-theme';
import { useRtl } from '../../utilities/utilities';
/**
 * @internal
 */
export const cartesianchartClassNames = {
  root: 'fui-cart__root',
  chartWrapper: 'fui-cart__chartWrapper',
  axisTitle: 'fui-cart__axisTitle',
  xAxis: 'fui-cart__xAxis',
  yAxis: 'fui-cart__yAxis',
  opacityChangeOnHover: 'fui-cart__opacityChangeOnHover',
  legendContainer: 'fui-cart__legendContainer',
  calloutContentRoot: 'fui-cart__calloutContentRoot',
  calloutDateTimeContainer: 'fui-cart__calloutDateTimeContainer',
  calloutContentX: 'fui-cart__calloutContentX',
  calloutBlockContainer: 'fui-cart__calloutBlockContainer',
  calloutBlockContainertoDrawShapefalse: 'fui-cart__calloutBlockContainertoDrawShapefalse',
  calloutBlockContainertoDrawShapetrue: 'fui-cart__calloutBlockContainertoDrawShapetrue',
  shapeStyles: 'fui-cart__shapeStyles',
  calloutlegendText: 'fui-cart__calloutlegendText',
  calloutContentY: 'fui-cart__calloutContentY',
  descriptionMessage: 'fui-cart__descriptionMessage',
  hover: 'fui-cart__hover',
  calloutInfoContainer: 'fui-cart__calloutInfoContainer',
  tooltip: 'fui-cart__tooltip',
  chartTitle: 'fui-cart__chartTitle'
};
/**
 * Base Styles
 */
const useStyles = /*#__PURE__*/__styles({
  root: {
    Bahqtrf: "fk6fouc",
    Be2twd7: "fkhj508",
    Bhrd7zp: "figsok6",
    Bg96gwp: "f1i3iumi",
    mc9l5x: "f22iagw",
    a9b677: "fly5x3f",
    Bqenvij: "f1l02sjl",
    Beiy3e4: "f1vx9l62",
    B68tc82: 0,
    Bmxbyg5: 0,
    Bpg54ce: "f1a3p1vp"
  },
  chartWrapper: {
    B68tc82: 0,
    Bmxbyg5: 0,
    Bpg54ce: "f1enuhaj"
  },
  axisTitle: {
    Bahqtrf: "fk6fouc",
    Be2twd7: "f13mqy1h",
    Bhrd7zp: "fl43uef",
    Bg96gwp: "fcpl73t",
    B80ckks: "fmd4ok8",
    fsow6f: "f17mccla",
    sj55zd: "fkfq4zb",
    Bkfmm31: "fhuob2q"
  },
  xAxis: {
    Bifops1: "fk6onyz",
    lr70ht: "f17odlr9",
    D01gh: "f1wvrikb",
    vxuu72: "fidmvdy",
    lclgl4: "f1noc3f3",
    Dzfv0s: "f1rtcel9",
    s17mou: "f4w8oyz",
    jxu3ei: "fkuun",
    B3i31d3: "f1u7a78k",
    Bhcy8il: "f1myyn02",
    t7r2jy: "f1ypwncy",
    Bpf2t2a: "fs22wna",
    J19x1g: "f19ju15u",
    se2xxg: "f1x8lysa"
  },
  yAxis: {
    lr70ht: "f17odlr9",
    D01gh: "f1wvrikb",
    vxuu72: "fidmvdy",
    lclgl4: "f1noc3f3",
    Bifops1: "fk6onyz",
    Dzfv0s: "f1rtcel9",
    s17mou: "f4w8oyz",
    jxu3ei: "fkuun",
    B3i31d3: "f1u7a78k",
    t7r2jy: "f1ypwncy",
    Bpf2t2a: "fs22wna",
    J19x1g: "f19ju15u",
    se2xxg: "f1x8lysa"
  },
  rtl: {
    Bkw34lo: "f1j2g1si"
  },
  ltr: {},
  opacityChangeOnHover: {
    abs64n: "f9das1l",
    Bceei9c: "f158kwzp"
  },
  legendContainer: {
    B6of3ja: "frnwi6n",
    Frg6f3: ["ff3wqvv", "f1l2akhw"]
  },
  calloutContentRoot: {
    mc9l5x: "f13qh94s",
    B68tc82: 0,
    Bmxbyg5: 0,
    Bpg54ce: "f1a3p1vp",
    z8tnut: "f1dvrhzg",
    z189sj: ["fjnv7mu", "fae8789"],
    Byoj8tv: "f1av7aef",
    uwmqm3: ["fae8789", "fjnv7mu"],
    De3pzq: "fxugw4r",
    jy2i9i: "fronft5"
  },
  calloutDateTimeContainer: {
    mc9l5x: "f22iagw",
    Beiy3e4: "f1063pyq",
    Brf1p80: "f1869bpl"
  },
  calloutContentX: {
    Bahqtrf: "fk6fouc",
    Be2twd7: "fy9rknc",
    Bhrd7zp: "figsok6",
    Bg96gwp: "fwrc4pm",
    abs64n: "fp25eh",
    sj55zd: "fkfq4zb"
  },
  calloutBlockContainer: {
    Bahqtrf: "fk6fouc",
    Be2twd7: "fod5ikn",
    Bhrd7zp: "figsok6",
    Bg96gwp: "faaz57k",
    B6of3ja: "f7jvbu2",
    sj55zd: "fkfq4zb"
  },
  calloutBlockContainertoDrawShapefalse: {
    B93v9kj: "f15mrrko",
    ibv6hh: ["frjpdoz", "fm1xp1g"],
    uwmqm3: ["f1f5gg8d", "f1vdfbxk"]
  },
  calloutBlockContainertoDrawShapetrue: {
    mc9l5x: "f22iagw"
  },
  shapeStyles: {
    t21cq0: ["f1vcna3q", "foyynoy"]
  },
  calloutLegendText: {
    Bahqtrf: "fk6fouc",
    Be2twd7: "fy9rknc",
    Bhrd7zp: "figsok6",
    Bg96gwp: "fwrc4pm",
    sj55zd: "fkfq4zb",
    Bd6j3yi: "f5klfrb",
    hbub2c: "f1f0smcx"
  },
  calloutContentY: {
    Bahqtrf: "fk6fouc",
    Be2twd7: "fod5ikn",
    Bhrd7zp: "flh3ekv",
    Bg96gwp: "faaz57k",
    Bd6j3yi: "f5klfrb",
    hbub2c: "f1f0smcx"
  },
  descriptionMessage: {
    Bahqtrf: "fk6fouc",
    Be2twd7: "fy9rknc",
    Bhrd7zp: "figsok6",
    Bg96gwp: "fwrc4pm",
    sj55zd: "fkfq4zb",
    B6of3ja: "f1gaxbfw",
    z8tnut: "f1ngh7ph",
    B4j52fo: "f1pgliyk"
  }
}, {
  d: [".fk6fouc{font-family:var(--fontFamilyBase);}", ".fkhj508{font-size:var(--fontSizeBase300);}", ".figsok6{font-weight:var(--fontWeightRegular);}", ".f1i3iumi{line-height:var(--lineHeightBase300);}", ".f22iagw{display:flex;}", ".fly5x3f{width:100%;}", ".f1l02sjl{height:100%;}", ".f1vx9l62{flex-direction:column;}", [".f1a3p1vp{overflow:hidden;}", {
    p: -1
  }], [".f1enuhaj{overflow:auto;}", {
    p: -1
  }], ".f13mqy1h{font-size:var(--fontSizeBase100);}", ".fl43uef{font-weight:var(--fontWeightSemibold);}", ".fcpl73t{line-height:var(--lineHeightBase100);}", ".fmd4ok8{font-style:normal;}", ".f17mccla{text-align:center;}", ".fkfq4zb{color:var(--colorNeutralForeground2);}", ".fhuob2q{fill:var(--colorNeutralForeground1);}", ".fk6onyz text{fill:var(--colorNeutralForeground1);}", ".f17odlr9 text{font-family:var(--fontFamilyBase);}", ".f1wvrikb text{font-size:var(--fontSizeBase100);}", ".fidmvdy text{font-weight:var(--fontWeightSemibold);}", ".f1noc3f3 text{line-height:var(--lineHeightBase100);}", ".fkuun line{opacity:0.2;}", ".f1u7a78k line{stroke:var(--colorNeutralForeground1);}", ".f1myyn02 line{width:1px;}", ".f1x8lysa path{display:none;}", ".f1j2g1si g{text-anchor:end;}", ".f9das1l{opacity:0.1;}", ".f158kwzp{cursor:default;}", ".frnwi6n{margin-top:var(--spacingVerticalS);}", ".ff3wqvv{margin-left:var(--spacingHorizontalXL);}", ".f1l2akhw{margin-right:var(--spacingHorizontalXL);}", ".f13qh94s{display:grid;}", [".f1a3p1vp{overflow:hidden;}", {
    p: -1
  }], ".f1dvrhzg{padding-top:11px 16px 10px 16px;}", ".fjnv7mu{padding-right:11px 16px 10px 16px;}", ".fae8789{padding-left:11px 16px 10px 16px;}", ".f1av7aef{padding-bottom:11px 16px 10px 16px;}", ".fxugw4r{background-color:var(--colorNeutralBackground1);}", ".fronft5{background-blend-mode:normal,luminosity;}", ".f1063pyq{flex-direction:row;}", ".f1869bpl{justify-content:space-between;}", ".fy9rknc{font-size:var(--fontSizeBase200);}", ".fwrc4pm{line-height:var(--lineHeightBase200);}", ".fp25eh{opacity:0.8;}", ".fod5ikn{font-size:var(--fontSizeBase400);}", ".faaz57k{line-height:var(--lineHeightBase400);}", ".f7jvbu2{margin-top:13px;}", ".frjpdoz{border-left-width:4px solid;}", ".fm1xp1g{border-right-width:4px solid;}", ".f1f5gg8d{padding-left:var(--spacingHorizontalS);}", ".f1vdfbxk{padding-right:var(--spacingHorizontalS);}", ".f1vcna3q{margin-right:var(--spacingHorizontalS);}", ".foyynoy{margin-left:var(--spacingHorizontalS);}", ".flh3ekv{font-weight:var(--fontWeightBold);}", ".f1gaxbfw{margin-top:var(--spacingVerticalMNudge);}", ".f1ngh7ph{padding-top:var(--spacingVerticalMNudge);}", ".f1pgliyk{border-top-width:1px solid var(--colorNeutralStroke2);}"],
  m: [["@media screen and (-ms-high-contrast: white-on-black),screen and (forced-colors: active) and (prefers-color-scheme: dark){.f1rtcel9 text{fill:rgb(179, 179, 179);}}", {
    m: "screen and (-ms-high-contrast: white-on-black), screen and (forced-colors: active) and (prefers-color-scheme: dark)"
  }], ["@media screen and (-ms-high-contrast: white-on-black),screen and (forced-colors: active) and (prefers-color-scheme: dark){.f4w8oyz text{forced-color-adjust:none;}}", {
    m: "screen and (-ms-high-contrast: white-on-black), screen and (forced-colors: active) and (prefers-color-scheme: dark)"
  }], ["@media screen and (-ms-high-contrast: white-on-black),screen and (forced-colors: active) and (prefers-color-scheme: dark){.f1ypwncy line{opacity:0.1;}}", {
    m: "screen and (-ms-high-contrast: white-on-black), screen and (forced-colors: active) and (prefers-color-scheme: dark)"
  }], ["@media screen and (-ms-high-contrast: white-on-black),screen and (forced-colors: active) and (prefers-color-scheme: dark){.fs22wna line{stroke:rgb(179, 179, 179);}}", {
    m: "screen and (-ms-high-contrast: white-on-black), screen and (forced-colors: active) and (prefers-color-scheme: dark)"
  }], ["@media screen and (-ms-high-contrast: white-on-black),screen and (forced-colors: active) and (prefers-color-scheme: dark){.f19ju15u line{forced-color-adjust:none;}}", {
    m: "screen and (-ms-high-contrast: white-on-black), screen and (forced-colors: active) and (prefers-color-scheme: dark)"
  }], ["@media screen and (-ms-high-contrast: active),screen and (forced-colors: active){.f15mrrko{forced-color-adjust:none;}}", {
    m: "screen and (-ms-high-contrast: active), screen and (forced-colors: active)"
  }], ["@media screen and (-ms-high-contrast: white-on-black),screen and (forced-colors: active) and (prefers-color-scheme: dark){.f5klfrb{color:rgb(255, 255, 255);}}", {
    m: "screen and (-ms-high-contrast: white-on-black), screen and (forced-colors: active) and (prefers-color-scheme: dark)"
  }], ["@media screen and (-ms-high-contrast: white-on-black),screen and (forced-colors: active) and (prefers-color-scheme: dark){.f1f0smcx{forced-color-adjust:none;}}", {
    m: "screen and (-ms-high-contrast: white-on-black), screen and (forced-colors: active) and (prefers-color-scheme: dark)"
  }]]
});
/**
 * Apply styling to the Carousel slots based on the state
 */
export const useCartesianChartStyles_unstable = props => {
  const _useRtl = useRtl();
  const baseStyles = useStyles();
  return {
    root: mergeClasses(cartesianchartClassNames.root, baseStyles.root /*props.styles?.root*/),
    chartWrapper: mergeClasses(cartesianchartClassNames.chartWrapper, baseStyles.chartWrapper /*props.styles?.chartWrapper*/),
    axisTitle: mergeClasses(cartesianchartClassNames.axisTitle, baseStyles.axisTitle /*props.styles?.axisTitle*/),
    xAxis: mergeClasses(cartesianchartClassNames.xAxis, baseStyles.xAxis /*props.styles?.xAxis*/),
    yAxis: mergeClasses(cartesianchartClassNames.yAxis, baseStyles.yAxis, _useRtl ? baseStyles.rtl : baseStyles.ltr /*props.styles?.yAxis*/),
    opacityChangeOnHover: mergeClasses(cartesianchartClassNames.opacityChangeOnHover, baseStyles.opacityChangeOnHover /*props.styles?.opacityChangeOnHover*/),
    legendContainer: mergeClasses(cartesianchartClassNames.legendContainer, baseStyles.legendContainer /*props.styles?.legendContainer*/),
    calloutContentRoot: mergeClasses(cartesianchartClassNames.calloutContentRoot, baseStyles.calloutContentRoot /*props.styles?. calloutContentRoot*/),
    calloutDateTimeContainer: mergeClasses(cartesianchartClassNames.calloutDateTimeContainer, baseStyles.calloutDateTimeContainer /*props.styles?.calloutDateTimeContainer*/),
    calloutContentX: mergeClasses(cartesianchartClassNames.calloutContentX, baseStyles.calloutContentX /*props.styles?.calloutContentX*/),
    calloutBlockContainer: mergeClasses(cartesianchartClassNames.calloutBlockContainer, baseStyles.calloutBlockContainer /*props.styles?.calloutBlockContainer*/),
    calloutBlockContainertoDrawShapefalse: mergeClasses(cartesianchartClassNames.calloutBlockContainertoDrawShapefalse, baseStyles.calloutBlockContainertoDrawShapefalse /*props.styles?.calloutBlockContainertoDrawShapefalse*/),
    calloutBlockContainertoDrawShapetrue: mergeClasses(cartesianchartClassNames.calloutBlockContainertoDrawShapetrue, baseStyles.calloutBlockContainertoDrawShapetrue /*props.styles?.calloutBlockContainertoDrawShapetrue*/),
    shapeStyles: mergeClasses(cartesianchartClassNames.shapeStyles, baseStyles.shapeStyles /*props.styles?.shapeStyles*/),
    calloutlegendText: mergeClasses(cartesianchartClassNames.calloutlegendText, baseStyles.calloutLegendText /*props.styles?.calloutlegendText*/),
    calloutContentY: mergeClasses(cartesianchartClassNames.calloutContentY, baseStyles.calloutContentY /*props.styles?.calloutContentY*/),
    descriptionMessage: mergeClasses(cartesianchartClassNames.descriptionMessage, baseStyles.descriptionMessage /*props.styles?. descriptionMessage*/)
  };
};
//# sourceMappingURL=useCartesianChartStyles.styles.js.map