import { __styles, mergeClasses, shorthands } from '@griffel/react';
import { tokens, typographyStyles } from '@fluentui/react-theme';
import { HighContrastSelector } from '../../utilities/index';
/**
 * @internal
 */
export const legendClassNames = {
  root: 'fui-legend__root',
  legend: 'fui-legend__legend',
  rect: 'fui-legend__rect',
  shape: 'fui-legend__shape',
  triangle: 'fui-legend__triangle',
  text: 'fui-legend__text',
  hoverChange: 'fui-legend__hoverChange',
  resizableArea: 'fui-legend__resizableArea'
};
const useStyles = /*#__PURE__*/__styles({
  root: {
    Huce71: "fz5stix",
    a9b677: "fly5x3f",
    Bt984gj: "f122n59",
    B6of3ja: "fpzxe1g",
    t21cq0: ["f705vk6", "fqom4eq"],
    jrapky: "fzpzak3",
    Frg6f3: ["fqom4eq", "f705vk6"]
  },
  legend: {
    Bt984gj: "f122n59",
    Brf1p80: ["fc7pyfw", "fgbriwd"],
    Bceei9c: "f1k6fduh",
    icvyot: "f1ern45e",
    vrafjx: ["f1n71otn", "f1deefiw"],
    oivjwe: "f1h8hb77",
    wvpqe5: ["f1deefiw", "f1n71otn"],
    z8tnut: "f17mpqex",
    z189sj: ["f1vdfbxk", "f1f5gg8d"],
    Byoj8tv: "fdvome7",
    uwmqm3: ["f1f5gg8d", "f1vdfbxk"],
    B9bfxx9: "fiwaqkr",
    Bs92zhm: "fuhkvgp",
    B93v9kj: "f15mrrko",
    Ck9m1r: "f1vu5irt",
    mkjk8h: "f1sdboh2"
  },
  rect: {
    zpeayv: "f81dvq6",
    Bcwlslt: "f1a000x3",
    a9b677: "frx94fk",
    Bgfg5da: 0,
    B9xav0g: 0,
    oivjwe: 0,
    Bn0qgzm: 0,
    B4g9neb: 0,
    zhjwy3: 0,
    wvpqe5: 0,
    ibv6hh: 0,
    u1mtju: 0,
    h3c5rm: 0,
    vrafjx: 0,
    Bekrc4i: 0,
    i8vvqc: 0,
    g2u3we: 0,
    icvyot: 0,
    B4j52fo: 0,
    irswps: "fpyyuzi",
    t21cq0: ["f1vcna3q", "foyynoy"]
  },
  shape: {
    t21cq0: ["f1vcna3q", "foyynoy"]
  },
  triangle: {
    a9b677: "f3tsq5r",
    Bqenvij: "fniina8",
    ibv6hh: ["fk1dseo", "f1r9b9o"],
    Bekrc4i: ["f1r9b9o", "fk1dseo"],
    B4j52fo: "f1cm5upi",
    t21cq0: ["f1vcna3q", "foyynoy"]
  },
  text: {
    Bahqtrf: "fk6fouc",
    Be2twd7: "fy9rknc",
    Bhrd7zp: "figsok6",
    Bg96gwp: "fwrc4pm",
    sj55zd: "f19n0e5",
    Bs92zhm: "fuhkvgp",
    B93v9kj: "f15mrrko"
  },
  hoverChange: {
    a9b677: "frx94fk",
    Bqenvij: "fvblgha",
    t21cq0: ["f1vcna3q", "foyynoy"],
    B4j52fo: "f1d7653x",
    Bekrc4i: ["f1maxq7k", "f16g4l54"],
    Bn0qgzm: "f1rzi0e7",
    ibv6hh: ["f16g4l54", "f1maxq7k"]
  },
  resizableArea: {
    qhf8xq: "f10pi13n",
    fsow6f: ["f1o700av", "fes3tcz"],
    Bz10aip: ["f15ivbov", "fjwp9lj"],
    Bhzewxz: "f198g47y",
    oyh7mz: ["f1ktbn1t", "ffenbu1"],
    Bf4jedk: "f93ek0f",
    B2u0y6b: "f1cgdal8",
    smv486: "f2b5gy5",
    u6pn5x: ["fk27hbk", "f1xelbol"],
    B4uzyy: "f1gw7v5p",
    Be2s5ez: ["f1xelbol", "fk27hbk"],
    xrcqlc: "f196ehyi",
    Bhxzhr1: ["frlu5y9", "f109kcev"]
  }
}, {
  d: [".fz5stix{white-space:nowrap;}", ".fly5x3f{width:100%;}", ".f122n59{align-items:center;}", ".fpzxe1g{margin-top:-8px 0 0 -8px;}", ".f705vk6{margin-right:-8px 0 0 -8px;}", ".fqom4eq{margin-left:-8px 0 0 -8px;}", ".fzpzak3{margin-bottom:-8px 0 0 -8px;}", ".fc7pyfw{justify-content:left;}", ".fgbriwd{justify-content:right;}", ".f1k6fduh{cursor:pointer;}", ".f1ern45e{border-top-style:none;}", ".f1n71otn{border-right-style:none;}", ".f1deefiw{border-left-style:none;}", ".f1h8hb77{border-bottom-style:none;}", ".f17mpqex{padding-top:var(--spacingHorizontalS);}", ".f1vdfbxk{padding-right:var(--spacingHorizontalS);}", ".f1f5gg8d{padding-left:var(--spacingHorizontalS);}", ".fdvome7{padding-bottom:var(--spacingHorizontalS);}", ".fiwaqkr{text-transform:capitalize;}", ".frx94fk{width:12px;}", [".fpyyuzi{border:1px solid;}", {
    p: -2
  }], ".f1vcna3q{margin-right:var(--spacingHorizontalS);}", ".foyynoy{margin-left:var(--spacingHorizontalS);}", ".f3tsq5r{width:0;}", ".fniina8{height:0;}", ".fk1dseo{border-left-width:6px solid transparent;}", ".f1r9b9o{border-right-width:6px solid transparent;}", ".f1cm5upi{border-top-width:10.4px solid;}", ".fk6fouc{font-family:var(--fontFamilyBase);}", ".fy9rknc{font-size:var(--fontSizeBase200);}", ".figsok6{font-weight:var(--fontWeightRegular);}", ".fwrc4pm{line-height:var(--lineHeightBase200);}", ".f19n0e5{color:var(--colorNeutralForeground1);}", ".fvblgha{height:12px;}", ".f1d7653x{border-top-width:1px solid;}", ".f1maxq7k{border-right-width:1px solid;}", ".f16g4l54{border-left-width:1px solid;}", ".f1rzi0e7{border-bottom-width:1px solid;}", ".f10pi13n{position:relative;}", ".f1o700av{text-align:left;}", ".fes3tcz{text-align:right;}", ".f15ivbov{transform:translate(-50%, 0);}", ".fjwp9lj{transform:translate(50%, 0);}", ".f198g47y{top:auto;}", ".f1ktbn1t{left:50%;}", ".ffenbu1{right:50%;}", ".f93ek0f{min-width:200px;}", ".f1cgdal8{max-width:800px;}", ".f2b5gy5::after{padding-top:1px 4px 1px;}", ".fk27hbk::after{padding-right:1px 4px 1px;}", ".f1xelbol::after{padding-left:1px 4px 1px;}", ".f1gw7v5p::after{padding-bottom:1px 4px 1px;}", ".f196ehyi::after{border-top-width:-2px;}", ".frlu5y9::after{border-left-width:-2px;}", ".f109kcev::after{border-right-width:-2px;}"],
  m: [["@media screen and (-ms-high-contrast: active),screen and (forced-colors: active){.fuhkvgp{color:WindowText;}}", {
    m: "screen and (-ms-high-contrast: active), screen and (forced-colors: active)"
  }], ["@media screen and (-ms-high-contrast: active),screen and (forced-colors: active){.f15mrrko{forced-color-adjust:none;}}", {
    m: "screen and (-ms-high-contrast: active), screen and (forced-colors: active)"
  }], ["@media screen and (-ms-high-contrast: active),screen and (forced-colors: active){.f1vu5irt:hover{color:HighlightText;}}", {
    m: "screen and (-ms-high-contrast: active), screen and (forced-colors: active)"
  }], ["@media screen and (-ms-high-contrast: active),screen and (forced-colors: active){.f1sdboh2:hover{forced-color-adjust:none;}}", {
    m: "screen and (-ms-high-contrast: active), screen and (forced-colors: active)"
  }], ["@media screen and (-ms-high-contrast: active),screen and (forced-colors: active){.f81dvq6{content:var(--rect-content-high-contrast);}}", {
    m: "screen and (-ms-high-contrast: active), screen and (forced-colors: active)"
  }], ["@media screen and (-ms-high-contrast: active),screen and (forced-colors: active){.f1a000x3{opacity:var(--rect-opacity-high-contrast);}}", {
    m: "screen and (-ms-high-contrast: active), screen and (forced-colors: active)"
  }]]
});
export const useLegendStyles_unstable = props => {
  var _props_styles, _props_styles1, _props_styles2, _props_styles3, _props_styles4, _props_styles5, _props_styles6, _props_styles7;
  const {
    className
  } = props; // ToDo - width, barHeight is non enumerable. Need to be used inline.
  const baseStyles = useStyles();
  return {
    root: mergeClasses(legendClassNames.root, baseStyles.root, className, (_props_styles = props.styles) === null || _props_styles === void 0 ? void 0 : _props_styles.root),
    legend: mergeClasses(legendClassNames.legend, baseStyles.legend, (_props_styles1 = props.styles) === null || _props_styles1 === void 0 ? void 0 : _props_styles1.legend),
    rect: mergeClasses(legendClassNames.rect, baseStyles.rect, (_props_styles2 = props.styles) === null || _props_styles2 === void 0 ? void 0 : _props_styles2.rect),
    shape: mergeClasses(legendClassNames.shape, baseStyles.shape, (_props_styles3 = props.styles) === null || _props_styles3 === void 0 ? void 0 : _props_styles3.shape),
    triangle: mergeClasses(legendClassNames.triangle, baseStyles.triangle, (_props_styles4 = props.styles) === null || _props_styles4 === void 0 ? void 0 : _props_styles4.triangle),
    text: mergeClasses(legendClassNames.text, baseStyles.text, (_props_styles5 = props.styles) === null || _props_styles5 === void 0 ? void 0 : _props_styles5.text),
    hoverChange: mergeClasses(legendClassNames.hoverChange, baseStyles.hoverChange, (_props_styles6 = props.styles) === null || _props_styles6 === void 0 ? void 0 : _props_styles6.hoverChange),
    resizableArea: mergeClasses(legendClassNames.resizableArea, baseStyles.resizableArea, (_props_styles7 = props.styles) === null || _props_styles7 === void 0 ? void 0 : _props_styles7.resizableArea)
  };
};
//# sourceMappingURL=useLegendsStyles.styles.js.map