import { __styles, mergeClasses, shorthands } from '@griffel/react';
import { tokens } from '@fluentui/react-theme';
/**
 * @internal
 */
export const linechartClassNames = {
  tooltip: 'fui-line__tooltip',
  root: 'fui-line__root',
  xAxis: 'fui-line__xAxis',
  yAxis: 'fui-line__yAxis',
  legendContainer: 'fui-line__legendContainer',
  hover: 'fui-line__hover',
  calloutContentRoot: 'fui-line__calloutContentRoot',
  calloutContentX: 'fui-line__calloutContentX',
  calloutContentY: 'fui-line__calloutContentY',
  descriptionMessage: 'fui-line__descriptionMessage',
  calloutDateTimeContainer: 'fui-line__calloutDateTimeContainer',
  calloutInfoContainer: 'fui-line__calloutInfoContainer',
  calloutBlockContainer: 'fui-line__calloutBlockContainer',
  calloutlegendText: 'fui-line__calloutLegendText',
  axisTitle: 'fui-line__axisTitle',
  chartTitle: 'fui-line__chartTitle',
  opacityChangeOnHover: 'fui-line__opacityChangeOnHover',
  shapeStyles: 'fui-line__shapeStyles',
  chartWrapper: 'fui-line__chartWrapper',
  calloutBlockContainertoDrawShapefalse: '',
  calloutBlockContainertoDrawShapetrue: ''
};
/**
 * Base Styles
 */
const useStyles = /*#__PURE__*/__styles({
  tooltip: {
    mc9l5x: "f22iagw",
    Beiy3e4: "f1vx9l62",
    z8tnut: "f17mpqex",
    z189sj: ["f1vdfbxk", "f1f5gg8d"],
    Byoj8tv: "fdvome7",
    uwmqm3: ["f1f5gg8d", "f1vdfbxk"],
    qhf8xq: "f1euv43f",
    fsow6f: "f17mccla",
    Bhzewxz: "fr6rvge",
    Bkfmm31: "f5q6cfr",
    Beyfa6y: 0,
    Bbmb7ep: 0,
    Btl43ni: 0,
    B7oj6ja: 0,
    Dimara: "fq9zq91",
    Bkecrkj: "f1aehjj5"
  }
}, {
  d: [".f22iagw{display:flex;}", ".f1vx9l62{flex-direction:column;}", ".f17mpqex{padding-top:var(--spacingHorizontalS);}", ".f1vdfbxk{padding-right:var(--spacingHorizontalS);}", ".f1f5gg8d{padding-left:var(--spacingHorizontalS);}", ".fdvome7{padding-bottom:var(--spacingHorizontalS);}", ".f1euv43f{position:absolute;}", ".f17mccla{text-align:center;}", ".fr6rvge{top:var(--spacingVerticalNone);}", ".f5q6cfr{fill:var(--colorNeutralBackground1);}", [".fq9zq91{border-radius:var(--borderRadiusSmall);}", {
    p: -1
  }], ".f1aehjj5{pointer-events:none;}"]
});
/**
 * Apply styling to the Carousel slots based on the state
 */
export const useLineChartStyles_unstable = props => {
  const baseStyles = useStyles();
  return {
    tooltip: mergeClasses(linechartClassNames.tooltip, baseStyles.tooltip /*props.styles?.tooltip*/)
  };
};
//# sourceMappingURL=useLineChartStyles.styles.js.map